//
//  CarouselTemplateViewController.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/18/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit
import RxSwift
import RxCocoa
import RxDataSources

protocol CarouselTemplatePresenterInterface: PresenterInterface {
}

final class CarouselCollectionViewFlowLayout: UICollectionViewFlowLayout {
    
    
    override func prepare() {
        super.prepare()
    }
    
    @discardableResult
    func setItemSize(_ size: CGSize) -> CarouselCollectionViewFlowLayout {
        itemSize = size
        return self
    }
    
    @discardableResult
    func setPadding(_ padding: CGFloat) -> CarouselCollectionViewFlowLayout {
        minimumInteritemSpacing = padding
        return self
    }
    
    @discardableResult
    func setScrollDirection(_ direction: UICollectionView.ScrollDirection) -> CarouselCollectionViewFlowLayout {
        scrollDirection = direction
        return self
    }
}

final class CarouselTemplateViewController: UIViewController, CarouselTemplateViewInterface {

    var style: CarouselTemplateStyle = .medium
    let viewModels = BehaviorRelay<[ProductCarouselCellViewModel]>(value: [])
    private lazy var dataSource = makeDataSource()
    
    @IBOutlet private weak var titleLabel: UILabel!
    @IBOutlet private weak var collectionView: UICollectionView!
    @IBOutlet private weak var collectionViewHeightConstraint: NSLayoutConstraint!
    // MARK: - Public properties -
    
    /// Internal
    private let viewDidLoadRelay = BehaviorRelay(value: false)
    private let disposeBag = DisposeBag()

    var presenter: CarouselTemplatePresenterInterface!

    // MARK: - Lifecycle -

    override func viewDidLoad() {
        super.viewDidLoad()
        defer {
            viewDidLoadRelay.accept(true)
        }
        configureViews()
        configurePresenter()
    }
}

// MARK: - Extensions -
extension CarouselTemplateViewController {
    private func configureViews() {
        
        titleLabel.setStyle(DS.T16M(color: Colors.ink500))
        configureCollectionView()
    }
    
    private func configureCollectionView() {
        collectionViewHeightConstraint.constant = style.mapToCellHeight
        let collectionViewLayout = CarouselCollectionViewFlowLayout()
            .setItemSize(
                CGSize(
                    width: style.mapToCellWidth,
                    height: style.mapToCellHeight
                )
            )
            .setPadding(16)
            .setScrollDirection(.horizontal)
        collectionView.collectionViewLayout = collectionViewLayout
        
        collectionView.showsVerticalScrollIndicator = false
        collectionView.showsHorizontalScrollIndicator = false
        collectionView.contentInset = UIEdgeInsets(top: .zero, left: UIConfig.cellPadding, bottom: .zero, right: .zero)
        
        registerCells()
    }
    
    private func registerCells() {
        collectionView.register(cellType: ProductCarouselCell.self)
    }
    
    enum UIConfig {
        static let cellPadding: CGFloat = 16
        static let smallCellHeight: CGFloat = smallCellWidth * 9 / 16 + 56
        static var smallCellWidth: CGFloat = (UIScreen.main.bounds.width * 0.95 - (cellPadding  * 2) - 16) / 2
    }
}

extension CarouselTemplateViewController {
    private func configurePresenter() {
        let didLoad = viewDidLoadRelay.asObservable()
        viewModels
            .filterEmpty()
            .takeLatestWhen(didLoad)
            .map { [Section(model: 0, items: $0)] }
            .asDriver(onErrorDriveWith: .never())
            .drive(collectionView.rx.items(dataSource: dataSource))
            .disposed(by: disposeBag)
    }
}

extension CarouselTemplateViewController {
    typealias Section = SectionModel<Int, ProductCarouselCellViewModel>
    typealias DataSource = RxCollectionViewSectionedReloadDataSource<Section>
}

extension CarouselTemplateViewController {
    func makeDataSource() -> DataSource {
        return DataSource { [weak self] (_, collectionView, indexPath, model) -> UICollectionViewCell in
            guard let self = self else { fatalError("Self not available")}
            let cell: ProductCarouselCell = collectionView.dequeueReusableCell(for: indexPath)
            cell.configureCell(viewModel: model, style: self.style)
            return cell
        }
    }
}

